 '-----------------------------------------------------------------------
 '                        R A N D G E N V I E W
 '-----------------------------------------------------------------------
 ' Displaying random numbers generated.
 '-----------------------------------------------------------------------
 ' Input files: RandGenView.scn / RandGen.dat
 ' Process: Conversion from DOS format to WIN32 console format
 '          of RandGenView.scn and display on console.
 '          Read of 5000 rows of 64 numbers from file RandGen.dat
 '
 ' Output:  Display the content of RandGen.dat on screen format
 '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 ' Date: 25-apr-2010 / release 0.1
 ' Language: PB/CC 5.04
 ' Author: frktons @ MASM32 Forum
 '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


 #INCLUDE "win32api.inc"


 DECLARE SUB ReadForm(BYVAL location AS LONG)

 DECLARE SUB DisplayScreen

 DECLARE SUB DisplayRandGen

 DECLARE SUB ConvertASM
 DECLARE SUB ReadRandFile

 GLOBAL n&(), g&()

 TYPE RandDataRec
     Num(1 TO 64) AS LONG
 END TYPE

 FUNCTION PBMAIN()

   GLOBAL MainStr AS STRING, sBuf AS STRING
   GLOBAL location AS LONG
   GLOBAL x,x1,x2,x3,x4,x5,x6,y,y1,y2,y3,y4,y5,y6, n_idx AS LONG

   DIM n&(1 TO 320000)

   GLOBAL ok, si, no AS LONG, first AS LONG, last AS LONG


   ok = 0
   si = -1
   no = 0

   last = 5000
   first = 1

   CONSOLE SCREEN 25,80

   CURSOR OFF

   CALL ReadForm(1)
   CALL ConvertASM

   CALL ReadRandFile
   CALL DisplayScreen

   COLOR 0,8

   CALL DisplayRandGen


 exit_pgm:

 END FUNCTION


'--------------------------------------------------------------------------------
' Display the converted Screen
'--------------------------------------------------------------------------------

 SUB DisplayScreen

    LOCAL lpReadRegion AS SMALL_RECT
    LOCAL SIZE AS DWORD
    SIZE = MAKDWD(80, 25)

    lpReadRegion.xRight = 79
    lpReadRegion.xBottom = 24
    WriteConsoleOutPut GetStdHandle(%STD_OUTPUT_HANDLE), _
    BYVAL STRPTR(sBuf),BYVAL SIZE, BYVAL 0&, lpReadRegion
 END SUB

'--------------------------------------------------------------------------------
' Read the DOS screen into the variabile MainStr
'--------------------------------------------------------------------------------

 SUB ReadForm(BYVAL location AS LONG)
    LOCAL ff AS LONG

    ff = FREEFILE
    OPEN "RandGenView.scn" FOR BINARY AS #ff
      SEEK ff, location
      GET$ #ff, 4000, MainStr
    CLOSE #ff

 END SUB

'--------------------------------------------------------------------------------
' Read file RandGen.dat into an array
'--------------------------------------------------------------------------------

 SUB ReadRandFile

    LOCAL ff AS LONG

    DIM DataRec AS RandDataRec

    n_idx = 1

    ff = FREEFILE
    OPEN "RandGen.dat" FOR RANDOM AS #ff LEN=256


    FOR x = 1 TO 5000
       GET #ff, x, DataRec
       FOR x1 = 1 TO 64
           n&(n_idx) = DataRec.Num(x1)
           INCR n_idx
       NEXT x1

    NEXT x

    CLOSE #ff

 END SUB

'--------------------------------------------------------------------------------
' Convert the DOS screen into WIN Console screen - ASM version
'--------------------------------------------------------------------------------
 SUB ConvertASM

    #REGISTER NONE

    ! push ebx
    ! push esi
    ! push edi
    ! push eax

    sBuf = SPACE$(8000)

       ! mov ebx, 1000
       ! mov esi, MainStr
       ! mov edi, sBuf
       Convert:
       ! mov eax, [esi]
       ! mov [edi], al
       ! mov [edi+2], ah
       ! bswap eax
       ! mov [edi+6], al
       ! mov [edi+4], ah
       ! add esi, 4
       ! add edi, 8
       ! dec ebx
       ! jnz Convert

    ! pop eax
    ! pop edi
    ! pop esi
    ! pop ebx

  END SUB

'--------------------------------------------------------------------------------
' Display file RandGen.dat on screen format with control keys
'--------------------------------------------------------------------------------

 SUB DisplayRandGen

    LOCAL n_rec AS LONG, n_row AS LONG, n_col AS LONG, actual AS LONG, control_k AS LONG
    LOCAL KeyPress AS STRING

    n_rec = 1
    actual = 1

 OneMore:

    n_rec = actual
    n_idx = (n_rec - 1) * 64 + 1

    LOCATE 9,40
    PRINT FORMAT$(n_rec,"0,000")

    FOR n_col = 3 TO 78 STEP 5
       FOR n_row = 15 TO 21 STEP 2

           LOCATE n_row, n_col
           PRINT FORMAT$(n&(n_idx),"00")
           INCR n_idx
       NEXT n_row

    NEXT n_col



    KeyPress = WAITKEY$

    IF LEN(KeyPress) = 2 THEN
      GOTO key_surf
    END IF

    IF KeyPress = CHR$(27) THEN
       GOTO exit_sub
    END IF

    actual = actual + 1

    IF actual > last THEN
       actual = first
    END IF

   GOTO OneMore

key_surf:

   control_k = ASC(KeyPress,2)

   SELECT CASE control_k

   CASE 81 ' PgDown
       actual = actual + 100
       GOTO AndNow
   CASE 77 ' Arrow ->
       actual = actual + 1
       GOTO AndNow
   CASE 80 ' Arrow Down
       actual = actual + 1
       GOTO AndNow
   CASE 73 '  PgUp
       actual = actual - 100
       GOTO AndNow
   CASE 75 ' Arrow <-
       actual = actual - 1
       GOTO AndNow
   CASE 72 ' Arrow Up
       actual = actual - 1
       GOTO AndNow
   CASE 79 ' End
       actual = last
       GOTO AndNow
   CASE 71 ' Home
       actual = first
       GOTO AndNow

   END SELECT

AndNow:

   IF actual > last THEN
      actual = first
      GOTO OneMore
   END IF
   IF actual < first THEN
      actual = last
   END IF
   GOTO OneMore

exit_sub:

 END SUB
